#include<iostream>
#include<time.h>
#include<iomanip>
#include<fstream>
#include<cstdlib>
#include<cstring>
using namespace std;

//Function Prototypes
void check(int &checkWhat, int minNum, int maxNum, bool isUsed[2][10]);
int cardCheck(int cardChoice, int deck[2][10]);
bool finished(bool matched[2][10]);
//End function prototypes


int main(){
	//In which I attempt to write an array of strings in C++. It is the facedown deck of cards. 
	//P.S. I figured out how to do this in C before I figured out how to do it in C++
	string hiddenDeck[2][10] = {{" 1"," 2"," 3"," 4"," 5"," 6"," 7"," 8"," 9","10"},{"11","12","13","14","15","16","17","18","19","20"}};

	//Define the array that will hold the values of each card.
	//Temporarily initialize it to specific values for debugging purposes.
	//int deck[2][10] = {{5,8,1,2,7,10,6,3,9,4},{8,10,3,5,2,9,7,1,4,6}};
	int deck[2][10];
	
	//The cardChoice variables only handle user input.
	//The deckCard variables are the value of the facedown card chosen by the user.
	int cardChoice1, cardChoice2, deckCard1, deckCard2;

	//This boolean array helps the program ask, "Are we there yet."
	//It also helps the check() function do its job.
	bool matched[2][10];

	//Set every index in the matched[][] array to false.
	for (int i=0; i<2; i++){
		for (int j=0; j<10; j++)
			matched[i][j] = false;
	}

	//Swap the index values of the deck[][] array randomly.
	//Comment this section out for a predictable outcome.
	srand(time(0));

	for (int c=0; c<2; c++){
		//Linearly intialize the values in the deck[][] array.
		for (int r=0; r<10; r++)
			deck[c][r] = r + 1;

		//We are now going to shuffle the deck.
	
		//Linearly select each index.
		for (int i=9; i>0; i--){
			//Select a random index from 0 to 9.
			int j = rand() % 10; 

			//Swap the two selected indexes with each other.
			int temporaryVariable = deck[c][i];
			deck[c][i] = deck[c][j];
			deck[c][j] = temporaryVariable;
		}
	}
	//End: the section to be commented out for a predictable outcome.


		//This do-while loop handles user input, output, and when to stop executing. 
		do{
			//displays the state of the deck each time.
			cout << "\n\n****************************************************\n";
			for (int r=0; r<2; r++){
                		for (int c=0; c<10; c++){
                                	cout << hiddenDeck[r][c] << ' ';
                		}
                	cout << endl;
			}


			//Code block handles first row of cards.
			cout << "What card would you like to pick from the first row?" << endl;
			cin >> cardChoice1;
			check(cardChoice1, 1, 10, matched);
			deckCard1 = cardCheck(cardChoice1, deck);
			cout << cardChoice1 << " is a(n) " << deckCard1;
			
			//Code block handles second row of cards.
			cout << "\nWhat card would you like to pick from the second row?" << endl;
			cin >> cardChoice2;
			check(cardChoice2, 11, 20, matched);
			deckCard2 = cardCheck(cardChoice2, deck);
			cout << cardChoice2 << " is a(n) " << deckCard2;

			//What to do after the user has chosen two cards.
			if (deckCard1 != deckCard2)
				cout << endl << "No match!\n";
			else{
				//The cards matched. Ok good. Here is what we do.
				//First, tell the user that they matched.
				//Second, set the respective indices of the matched[][] array to true.
				//Third, remove the upside down cards from the hiddenDeck[][] string.
				cout << endl << "Match!\n";
				matched[0][cardChoice1-1] = true;
				matched[1][cardChoice2-11] = true;
				hiddenDeck[0][cardChoice1-1] = " X";
				hiddenDeck[1][cardChoice2-11] = " X";
			}

		}while(!finished(matched));

		cout << endl << "All cards Matched! Game Over!" << endl;

	return 0;

}



//Originally this loop was in the check() function.
//But then I realized that I'll need to use it several
//times in that particular function.
void max_minCheck(int &checkWhat, int minNum, int maxNum){
        while ((checkWhat > maxNum || checkWhat < minNum)){
                cout << "Error: card number is not an option. Please choose a card numbered from " << minNum << " to " << maxNum << '.' << endl;
                cin >> checkWhat;
        }
} //this function does not need a function prototype.


//check() ensures that the player chooses a number within
//the range of available cards and one that isn't already matched.
void check(int &checkWhat, int minNum, int maxNum, bool isUsed[2][10]){

	max_minCheck(checkWhat, minNum, maxNum);

	//If statemtent tells the computer which row of the array to use.
	if (minNum == 1 && maxNum == 10){
		while (isUsed[0][checkWhat - 1] == true){
			cout << "Error: Ensure that you haven't already picked this card." << endl;
			cin >> checkWhat;
			max_minCheck(checkWhat, minNum, maxNum);
		}
	}else{
		while (isUsed[1][checkWhat - 11] == true){
			cout << "Error: Ensure that you haven't already picked this card." << endl;
			cin >> checkWhat;
			max_minCheck(checkWhat, minNum, maxNum);
		}
	}
}

//cardCheck() converts the user input of 1-10 or 11-20
//to an index value 0-9 for the deck[][] array.
int cardCheck(int cardChoice, int deck[2][10]){
	
	int chosenCard; //This is the value of card that was chosen.

	//If we are dealing with user input 1-10, then we need only the first row.
		for (int x=1; x<=10;x++){
			if (cardChoice == x)
			       chosenCard = deck[0][x-1]; //ensure index value remains at 0-9.
		}

	//If we are dealing with user input 11-20, then we need only the second row.
		for (int y=11; y<=20;y++){
			if (cardChoice == y)
				chosenCard = deck[1][y-11]; //ensure that index value remains at 0-9.
		}

	return chosenCard;
}//Unfortunately, this was efficient to write, but it isn't efficient to execute.


//finished() returns true if the user has completed the game.
bool finished(bool matched[2][10]){
	bool verdict = true;

	//Search through the entire matched[][] array.
	//If even one value is false, verdict is false.
	//If all values are true, verdict is true.
	for (int c=0; c<2; c++){
		for (int r=0; r<10 && verdict != false; r++){
			if (matched[c][r] == false)
				verdict = false;
			else
				verdict = true;
		}
	}

	return verdict;
}
